<template>
  <div class="loading" v-show="loading" role="alert">
    <Loading></Loading>
  </div>
  <div v-if="isDataLoaded">
    <Subject class="subject" v-for="(subject, index) in trajectoryContent1(id).subjects"
             :key="'subject' + index"
             :data="subject"></Subject>
  </div>

  <div class="btn">
    <PrimeBtn v-if="trajectoryContent1(id).favorite === 0" class="fav"
              :value="'Aan favorieten toevoegen'"
              @click="favTrajectory1(id)"></PrimeBtn>

    <PrimeBtn v-if="trajectoryContent1(id).favorite === 1" class="fav"
              :value="'Uit favorieten verwijderen'"
              @click="favTrajectory1(id)"></PrimeBtn>

    <PrimeBtn v-if="trajectoryContent1(id).shared === 0"
              class="share" :value="'Delen'"
              @click="shareTrajectory1(id)"></PrimeBtn>
    <PrimeBtn class="delete" :value="'Verwijderen'" @click="deleteTrajectory1(id)"></PrimeBtn>

    <PrimeBtn class="delete" :value="'print'" @click="printPage()"></PrimeBtn>
  </div>

</template>

<script>
import Subject from '@/components/UI/molecules/Subject.vue';
import PrimeBtn from '@/components/UI/atoms/PrimeBtn.vue';
import Loading from '@/components/UI/atoms/Loading.vue';

import { mapGetters, mapActions } from 'vuex';

export default {
  name: 'TrajectoryContent',
  components: { Loading, Subject, PrimeBtn },
  data() {
    return {
      id: this.$route.params.id,
      loading: false,
    };
  },
  methods: {
    ...mapGetters('trajectories', ['trajectories']),
    ...mapActions('trajectories', ['deleteTrajectory']),
    ...mapActions('trajectories', ['shareTrajectory']),
    ...mapActions('trajectories', ['favTrajectory']),
    // eslint-disable-next-line consistent-return
    trajectoryContent1(id) {
      if (!this.trajectory.find((trajectory) => trajectory.id === parseInt(id, 10))) {
        this.$router.push({ name: 'Trajectories' });
      } else {
        const subjects = this.trajectory
          .find((trajectory) => trajectory.id === parseInt(id, 10));
        return subjects;
      }
    },
    /* eslint-disable */
    async shareTrajectory1(id) {
      // eslint-disable-next-line no-restricted-globals
      if (confirm('Weet je zeker dat je dit traject wilt delen?')) {
        this.loading = true;
        try {
          await this.shareTrajectory(id);
        } finally {
          await this.$store.dispatch('trajectories/getTrajectories');
          await this.$router.push({ name: 'Trajectories' });
        }
      }
    },

    async favTrajectory1(id) {
      // eslint-disable-next-line no-restricted-globals
      this.loading = true;
      try {
        await this.favTrajectory(id);
      } finally {
        await this.$store.dispatch('trajectories/getTrajectories');
        await this.$router.push({ name: 'Trajectories' });
      }
    },

    async deleteTrajectory1(id) {
      // eslint-disable-next-line no-restricted-globals
      if (confirm('Weet je zeker dat je dit traject wilt verwijderen?')) {
        this.loading = true;
        try {
          await this.deleteTrajectory(id);
        } finally {
          await this.$store.dispatch('trajectories/getTrajectories');
          await this.$router.push({ name: 'Trajectories' });
        }
      }
    },
    printPage() {
      window.print();
    },
  },
  computed: {
    trajectory() {
      return this.trajectories();
    },
    isDataLoaded() {
      const loaded = this.trajectories();
      return loaded.length !== 0;
    },
  },
};
</script>

<style scoped lang="scss">

  .subject{
    margin: 20px auto;
  }
  .btn{
    width: 50%;
    margin: 50px auto;
    display: flex;
    justify-content: space-around;
    flex-wrap: wrap;
  }
  .fav{
    background-color: $custom_green;
    padding: 0 10px;
    width: 250px;
  }
  .share{
    background-color: $custom_blue;
  }
  .delete{
    background-color: $custom_red;
  }
  @media only screen and (max-width: 1128px){
    .btn{
      flex-direction: column;
      align-items: center;
    }
    .fav{
      margin-top: 10px;
    }
    .share{
      margin-top: 10px;
    }
    .delete{
      margin-top: 10px;
    }
    @media only screen and (max-width: 800px){
      .subject{
        width: 85%;
      }
    }
  }
</style>
